#Autogenerated class


from xml.dom.minidom import parseString

from bioMoby.mobyDataTypes import MobyInteger
from bioMoby.mobyDataTypes import MobyString
from BasicGFFSequenceFeature import MobyBasicGFFSequenceFeature
from DNASequence import MobyDNASequence


class MobyDNASequenceWithGFFFeatures(MobyDNASequence):
    """ Description: A DNA Sequence including GFF-style features. HINT: the id attribute of this object should be equivalent to the 'reference' String component of each contained BasicGFFSequenceFeature object, or it wont make much sense.
        Author: www.illuminae.com
        Contact: markw@illuminae.com
    """
    def __init__(self,namespace="",id="",Length=0,SequenceString="",DNASequenceWithGFFFeatures=[],articleName=""):
        self._articles={"Length":"Length","SequenceString":"SequenceString","DNASequenceWithGFFFeatures":"DNASequenceWithGFFFeatures"}
        self.namespace=namespace
        self.id=id
        self.Length=Length
        self.SequenceString=SequenceString
        self.DNASequenceWithGFFFeatures=DNASequenceWithGFFFeatures
        self.__prefix__="moby"
        self.__tag__="DNASequenceWithGFFFeatures"
        self.articleName=articleName


    def fromMoby(self, value):

        """ Load the attributes from an XML string
        """
        from bioMoby.mobyMarshal import MobyUnmarshaller
        doc=value
        if isinstance(value,str):
            doc=parseString(value).firstChild
        um=MobyUnmarshaller()
        self.content=""
        self.namespace=doc.getAttribute("moby:namespace")
        if self.namespace=="":
            self.namespace=doc.getAttribute("namespace")
        self.id=doc.getAttribute("moby:id")
        if self.id=="":
            self.id=doc.getAttribute("id")

        self.articleName=doc.getAttribute("moby:articleName")
        if self.articleName=="":

            self.articleName=doc.getAttribute("articleName")
        self.DNASequenceWithGFFFeatures=[]
        for elt in doc.childNodes:
            if elt.nodeType==elt.TEXT_NODE or elt.nodeType==elt.CDATA_SECTION_NODE:
                self.content=self.content+elt.nodeValue
            if elt.nodeName=="CrossReference" or elt.nodeName=="moby:CrossReference":
                self.__cross__=[]
                for ref in elt.childNodes:
                    self.__cross__.append(ref)
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="Integer" or elt.nodeName=="moby:Integer") and (elt.getAttribute("articleName")=="Length" or elt.getAttribute("moby:articleName")=="Length"):
                t=MobyInteger()
                t.fromMoby(elt)
                self.Length=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="String" or elt.nodeName=="moby:String") and (elt.getAttribute("articleName")=="SequenceString" or elt.getAttribute("moby:articleName")=="SequenceString"):
                t=MobyString()
                t.fromMoby(elt)
                self.SequenceString=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="BasicGFFSequenceFeature" or elt.nodeName=="moby:BasicGFFSequenceFeature") and (elt.getAttribute("articleName")=="DNASequenceWithGFFFeatures" or elt.getAttribute("moby:articleName")=="DNASequenceWithGFFFeatures"):
                auxObject=MobyBasicGFFSequenceFeature()
                auxObject.fromMoby(elt)
                self.DNASequenceWithGFFFeatures.append(auxObject)